/**********************************************************************
 *<
	FILE: SuperUtility.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: David Lanier dlanier@kalisto.com
				http://www.kalisto.com
	HISTORY: Created the 18th of April 2000

 *>	Copyright (c) 1997, All Rights Reserved.
 **********************************************************************/

#include "Precomp.h"

//Globals
extern ClassDesc2*	GetSuperUtilityDesc();
extern Interface*	ip;
extern BOOL			IsOurDialogVisible;

static BOOL CALLBACK MyDialogDlgProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_INITDIALOG:
		{
			ShowWindow(hWnd,SW_SHOW);
			FillTheComboBox(hWnd);	
		}
		break;

		case WM_CLOSE:
		case WM_DESTROY:
		{
			IsOurDialogVisible = FALSE;
			ip->UnRegisterDlgWnd(hWnd);
			DestroyWindow(hWnd);
		}
		break;

		case WM_COMMAND:
		{
			switch(wParam)
			{
				case IDC_BUTTON_ADDEDITMESH:
				{
					//Get the selected sub object level in our combo
					int SubObjectLevel = GetSubObjectLevelFromComboBox(hWnd);

					//Add the dit mesh modifier and returns its pointer
					Modifier* EditMesh = PutEditMeshOnTopOfStack(SubObjectLevel);
				}
				break;

				case IDC_BUTTON_COLLAPSE:
				{
					Collapse();
				}
				break;
				
			}
			break;
		}
		break;

		default:
			return FALSE;
	}
	return TRUE;
}

static BOOL CALLBACK SuperUtilityDlgProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hWndDialog	= NULL;
	static BOOL	OnlyOnce	= TRUE;

	switch (msg) 
	{
		case WM_INITDIALOG:
		{
			theSuperUtility.Init(hWnd);
			//The first time
			if (!IsOurDialogVisible)
			{
				Interface* _ip = GetCOREInterface();
				hWndDialog = CreateDialog(
				  hInstance,						// handle to module
				  MAKEINTRESOURCE(IDD_MYDIALOG),	// dialog box template name
				  _ip->GetMAXHWnd(),				// handle to owner window
				  &MyDialogDlgProc					// dialog box procedure
				);
				IsOurDialogVisible = TRUE; //Memorize that our dialog is visible
				_ip->RegisterDlgWnd(hWndDialog);
			}
		}
		break;

		case WM_DESTROY:
		{
			theSuperUtility.Destroy(hWnd);
			GetCOREInterface()->UnRegisterDlgWnd(hWndDialog);
		}
		break;

		case WM_COMMAND:
		switch(wParam)
		{
			case IDC_BUTTON_KALISTO:
			{
				const int Err = reinterpret_cast<int>( ShellExecute(hWnd, NULL, "http://www.kalisto.com", NULL, NULL, NULL) );
				if (Err <32)
					MessageBox(NULL, "You don't have an internet access or it is not properly installed !","Error",MB_OK);
			}
			break;
			case IDC_BUTTON_DLANIER:
			{
				const int Err = reinterpret_cast<int> ( ShellExecute(hWnd, NULL, "mailto:dlanier@kalisto.com", NULL, NULL, NULL) );
				if (Err <32)
					MessageBox(NULL,"Please email at dlanier@kalisto.com because I can't open your email program","Error",MB_OK);
			}
			break;
			case IDC_BUTTON_OPEN:
			{
				//Check if it already opened
				if ( ! IsOurDialogVisible)
				{
					//No so create it register it
					Interface* _ip = GetCOREInterface();
					hWndDialog = CreateDialog(
					  hInstance,						// handle to module
					  MAKEINTRESOURCE(IDD_MYDIALOG),	// dialog box template name
					  _ip->GetMAXHWnd(),				// handle to owner window
					  &MyDialogDlgProc					// dialog box procedure
					);
					IsOurDialogVisible = TRUE; //Memorize that our dialog is visible
					_ip->RegisterDlgWnd(hWndDialog);
				}		
			}
			break;
		}
		break;


		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_MOUSEMOVE:
			ip->RollupMouseMessage(hWnd,msg,wParam,lParam); 
			break;

		default:
			return FALSE;
	}
	return TRUE;
}



//--- SuperUtility -------------------------------------------------------
SuperUtility::SuperUtility()
{
	iu = NULL;
	ip = NULL;	
	hPanel = NULL;
}

SuperUtility::~SuperUtility()
{

}

void SuperUtility::BeginEditParams(Interface *_ip,IUtil *iu) 
{
	this->iu = iu;
	ip		 = _ip;
	hPanel = ip->AddRollupPage(
		hInstance,
		MAKEINTRESOURCE(IDD_PANEL),
		SuperUtilityDlgProc,
		GetString(IDS_PARAMS),
		0);
}
	
void SuperUtility::EndEditParams(Interface *ip,IUtil *iu) 
{
	this->iu = NULL;
	ip->DeleteRollupPage(hPanel);
	hPanel = NULL;
}

void SuperUtility::Init(HWND hWnd)
{

}

void SuperUtility::Destroy(HWND hWnd)
{

}

